# Programm aufg8.4  
# zur Loesung von gew. DGL 1. Ordnung y'=f(x,y), y(x0)=y0
# implizites Runge-Kutta-Verfahren 4. Ordnung
# input:  Schrittweite h, Intervallgrenzen x0,x1, Anfangswert y0=y(x0) 
# output: Loesung y(x) an den Punkten x
# benutztes Programm: Nutzerfunktion f (rechte Seite der Dgl.)
# Aufruf: [y,x] = aufg84(x0,x1,y0,h,epsilon)
function [y,x] = aufg84(x0,x1,y0,h,epsilon);
n = (x1 - x0)/h;
yn = y0; y(1)=y0;
xn = x0; x(1)=x0; 
for k=1:n
   k1 = f(xn,yn);k2=f(xn,yn);k1a = k1+epsilon;k2a = k2+epsilon;
   while (abs(k1-k1a)+abs(k2-k2a) > epsilon) 
     k1a = k1;k2a = k2;
     k1 = f(xn + h*(3-sqrt(3))/6,yn + h*k1/4 + h*k2*(3-2*sqrt(3))/12);
     k2 = f(xn + h*(3+sqrt(3))/6,yn + h*k1*(3-2*sqrt(3))/12 + h*k2/4);
   endwhile
   yn = yn + 0.5*h*(k1+k2);
   xn = xn+h; x(k+1)=xn; y(k+1)=yn;
endfor
endfunction
