# Programm aufg44 von-Mises-Vektoriteration
# input:  pos. definite symmertische Matrix a, Toleranz epsilon
# output: groesster Eigenwert und der dazugehoerende Eigenvektor
# aufruf: [lambda,v,iter] = aufg44(a,epsilon);
function [lambda,v,iter] = aufg44(a,epsilon);
n = length(a(:,1));
z = ones(n,1); z(1) = z(1)+0.5;
v = ones(n,1); v = v/norm(v); v(1)=v(1)+0.5; va=v; zeta=1;
lambda = -1; lambdaa = -2;
iter = 0;
while (abs(lambda-lambdaa) > epsilon && iter < 50)
  v = a*va;
  if (iter > 0)
    lambdaa = lambda;
  endif
  if (va'*z == 0)
    z(1) = z(1) + 0.5;
  endif
  lambda = (v'*z)/(va'*z);
  va = v;
  zeta = 0;
  for i=1:n
    if (v(i) ~= 0 && zeta == 0)
      if (v(i) < 0)
        zeta = -1;
      endif
      if (v(i) > 0)
        zeta = 1;
      endif
    endif
  endfor
  v = zeta/(norm(v))*v;
  iter = iter+1;
endwhile
endfunction
